package com.its.bis.ui;

import com.intellij.uiDesigner.core.GridConstraints;
import com.intellij.uiDesigner.core.GridLayoutManager;
import com.intellij.uiDesigner.core.Spacer;
import com.its.app.AppUtils;
import com.its.app.utils.SysUtils;
import com.its.bis.config.DebugConfig;
import com.its.bis.config.ServerConfig;
import com.sun.management.OperatingSystemMXBean;
import lombok.Getter;
import lombok.extern.slf4j.Slf4j;

import javax.swing.*;
import javax.swing.plaf.FontUIResource;
import javax.swing.text.StyleContext;
import java.awt.*;
import java.awt.datatransfer.Clipboard;
import java.awt.datatransfer.StringSelection;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.io.IOException;
import java.lang.management.ManagementFactory;
import java.util.Locale;

@Slf4j
@Getter
public class MainUI {
    private static MainUI _instance = null;

    private JFrame jFrame = null;
    private final OperatingSystemMXBean osBean = (OperatingSystemMXBean) ManagementFactory.getOperatingSystemMXBean();
    private Timer timer;
    private Long tick = Long.valueOf(0);

    private JPanel rootPanel;
    private JPanel pnlLog;
    private JPanel pnlLogTitle;
    private JButton btnLogDirOpen;
    private JButton btnLogPause;
    private JCheckBox chkLogPause;
    private JLabel lblSystime;
    private JPanel pnlStatusBar;
    private JTextArea taLog;
    private JButton btnLogCopy;
    private JLabel lblCpuRate;
    private JLabel lblMemoryUsage;
    private JTextField txtPort;
    private JTextField txtApiPort;
    private JCheckBox chkSysDebug;
    private boolean isUpdatable;

    public static MainUI getInstance() {
        return _instance;
    }

    public void displaySystime() {
        lblSystime.setText(" " + SysUtils.getSysTimeStr() + "  ");
    }

    public void displayResource() {
        long memoryUsage = Math.round(((double) (osBean.getTotalPhysicalMemorySize() - osBean.getFreePhysicalMemorySize())) / (double) osBean.getTotalPhysicalMemorySize() * 100.0);
        lblMemoryUsage.setText(String.valueOf(memoryUsage));
        double cpuLoad = osBean.getSystemCpuLoad();
        if (cpuLoad >= 0.0 && cpuLoad <= 1.0) {
            lblCpuRate.setText(String.valueOf(Math.round(cpuLoad * 100.0)));
        } else {
            lblCpuRate.setText("---");
        }
    }

    public MainUI(JFrame jFrame) {
        System.setProperty("awt.useSystemAAFontSettings", "false"); // AntiAliasing false

        this.isUpdatable = false;
        this.jFrame = jFrame;
        if (_instance == null) {
            _instance = this;
        }

        try {
            Font font = Font.createFont(Font.TRUETYPE_FONT, new File("fonts/D2Coding.ttc"));
            GraphicsEnvironment ge = GraphicsEnvironment.getLocalGraphicsEnvironment();
            ge.registerFont(font);
        } catch (FontFormatException | IOException e) {
        }
        Font d2font = new Font("D2Coding", Font.PLAIN, 14);
        taLog.setFont(d2font);

        displaySystime();
        displayResource();
        timer = new Timer(1000, new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                displaySystime();
                tick++;
                if (tick % 5 == 0) {
                    displayResource();
                }
            }
        });
        timer.start();

        chkLogPause.setFocusable(false);
        btnLogPause.setFocusable(false);
        btnLogDirOpen.setFocusable(false);
        btnLogCopy.setFocusable(false);

        //initTblListUI();

        btnLogPause.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                taLog.setText(null);
            }
        });
        btnLogDirOpen.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                Runtime rt = Runtime.getRuntime();
                try {
                    rt.exec("explorer.exe logs");
                } catch (IOException ex) {
                    throw new RuntimeException(ex);
                }
            }
        });
        chkLogPause.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                JTextAreaOutputStream.isLoggingPause = chkLogPause.isSelected();
            }
        });
        btnLogCopy.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                StringSelection stringSelection = new StringSelection(taLog.getText());
                Clipboard clpBrd = Toolkit.getDefaultToolkit().getSystemClipboard();
                clpBrd.setContents(stringSelection, null);
            }
        });

        chkSysDebug.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                DebugConfig debug = (DebugConfig) AppUtils.getBean(DebugConfig.class);
                debug.setDebug(chkSysDebug.isSelected());
            }
        });

        ServerConfig serverConfig = (ServerConfig) AppUtils.getBean(ServerConfig.class);
        txtApiPort.setText(String.valueOf(serverConfig.getPort()));
        DebugConfig debug = (DebugConfig) AppUtils.getBean(DebugConfig.class);
        chkSysDebug.setSelected(debug.isDebug());
    }

    public static void error(String msg) {
        MainUI UI = MainUI.getInstance();
        if (UI == null || UI.chkLogPause.isSelected()) {
            return;
        }
        synchronized (UI.taLog) {
            if (UI.taLog.getLineCount() > 2000) {
                UI.taLog.setText(null);
            }
            UI.taLog.append(msg);
            UI.taLog.setCaretPosition(UI.taLog.getDocument().getLength());
        }
    }

    public static void info(String msg) {
        MainUI UI = MainUI.getInstance();
        if (UI == null || UI.chkLogPause.isSelected()) {
            return;
        }
        synchronized (UI.taLog) {
            synchronized (UI.taLog) {
                if (UI.taLog.getLineCount() > 2000) {
                    UI.taLog.setText(null);
                }
                UI.taLog.append(msg);
                UI.taLog.setCaretPosition(UI.taLog.getDocument().getLength());
            }
        }
    }


    {
// GUI initializer generated by IntelliJ IDEA GUI Designer
// >>> IMPORTANT!! <<<
// DO NOT EDIT OR ADD ANY CODE HERE!
        $$$setupUI$$$();
    }

    /**
     * Method generated by IntelliJ IDEA GUI Designer
     * >>> IMPORTANT!! <<<
     * DO NOT edit this method OR call it in your code!
     *
     * @noinspection ALL
     */
    private void $$$setupUI$$$() {
        rootPanel = new JPanel();
        rootPanel.setLayout(new GridLayoutManager(2, 1, new Insets(0, 0, 0, 0), -1, -1));
        pnlStatusBar = new JPanel();
        pnlStatusBar.setLayout(new GridLayoutManager(1, 9, new Insets(0, 4, 4, 4), -1, -1));
        rootPanel.add(pnlStatusBar, new GridConstraints(1, 0, 1, 1, GridConstraints.ANCHOR_CENTER, GridConstraints.FILL_BOTH, GridConstraints.SIZEPOLICY_CAN_SHRINK | GridConstraints.SIZEPOLICY_CAN_GROW, GridConstraints.SIZEPOLICY_CAN_SHRINK | GridConstraints.SIZEPOLICY_CAN_GROW, null, null, null, 0, false));
        final Spacer spacer1 = new Spacer();
        pnlStatusBar.add(spacer1, new GridConstraints(0, 3, 1, 1, GridConstraints.ANCHOR_CENTER, GridConstraints.FILL_HORIZONTAL, GridConstraints.SIZEPOLICY_WANT_GROW, 1, null, null, null, 0, false));
        lblSystime = new JLabel();
        Font lblSystimeFont = this.$$$getFont$$$("Malgun Gothic", Font.BOLD, 12, lblSystime.getFont());
        if (lblSystimeFont != null) lblSystime.setFont(lblSystimeFont);
        lblSystime.setHorizontalAlignment(0);
        lblSystime.setHorizontalTextPosition(0);
        lblSystime.setText(" 2022-08-04 13:24:33 ");
        pnlStatusBar.add(lblSystime, new GridConstraints(0, 8, 1, 1, GridConstraints.ANCHOR_CENTER, GridConstraints.FILL_NONE, GridConstraints.SIZEPOLICY_FIXED, GridConstraints.SIZEPOLICY_FIXED, null, null, null, 0, false));
        final JLabel label1 = new JLabel();
        label1.setIcon(new ImageIcon(getClass().getResource("/static/image/on.png")));
        label1.setText(" ");
        pnlStatusBar.add(label1, new GridConstraints(0, 0, 1, 1, GridConstraints.ANCHOR_WEST, GridConstraints.FILL_NONE, GridConstraints.SIZEPOLICY_FIXED, GridConstraints.SIZEPOLICY_FIXED, null, null, null, 0, false));
        lblCpuRate = new JLabel();
        Font lblCpuRateFont = this.$$$getFont$$$("Malgun Gothic", Font.BOLD, 12, lblCpuRate.getFont());
        if (lblCpuRateFont != null) lblCpuRate.setFont(lblCpuRateFont);
        lblCpuRate.setHorizontalAlignment(2);
        lblCpuRate.setHorizontalTextPosition(0);
        lblCpuRate.setText("    ");
        pnlStatusBar.add(lblCpuRate, new GridConstraints(0, 7, 1, 1, GridConstraints.ANCHOR_WEST, GridConstraints.FILL_NONE, GridConstraints.SIZEPOLICY_FIXED, GridConstraints.SIZEPOLICY_FIXED, new Dimension(40, -1), new Dimension(40, -1), new Dimension(40, -1), 0, false));
        lblMemoryUsage = new JLabel();
        Font lblMemoryUsageFont = this.$$$getFont$$$("Malgun Gothic", Font.BOLD, 12, lblMemoryUsage.getFont());
        if (lblMemoryUsageFont != null) lblMemoryUsage.setFont(lblMemoryUsageFont);
        lblMemoryUsage.setHorizontalAlignment(2);
        lblMemoryUsage.setHorizontalTextPosition(0);
        lblMemoryUsage.setText("    ");
        pnlStatusBar.add(lblMemoryUsage, new GridConstraints(0, 5, 1, 1, GridConstraints.ANCHOR_WEST, GridConstraints.FILL_NONE, GridConstraints.SIZEPOLICY_FIXED, GridConstraints.SIZEPOLICY_FIXED, new Dimension(40, -1), new Dimension(40, -1), new Dimension(40, -1), 0, false));
        final JLabel label2 = new JLabel();
        Font label2Font = this.$$$getFont$$$("Malgun Gothic", Font.PLAIN, 12, label2.getFont());
        if (label2Font != null) label2.setFont(label2Font);
        label2.setHorizontalAlignment(0);
        label2.setHorizontalTextPosition(0);
        label2.setText("  CPU 사용율(%):");
        pnlStatusBar.add(label2, new GridConstraints(0, 6, 1, 1, GridConstraints.ANCHOR_CENTER, GridConstraints.FILL_NONE, GridConstraints.SIZEPOLICY_FIXED, GridConstraints.SIZEPOLICY_FIXED, null, null, null, 0, false));
        final JLabel label3 = new JLabel();
        Font label3Font = this.$$$getFont$$$("Malgun Gothic", Font.PLAIN, 12, label3.getFont());
        if (label3Font != null) label3.setFont(label3Font);
        label3.setHorizontalAlignment(0);
        label3.setHorizontalTextPosition(0);
        label3.setText("  메모리 사용율(%):");
        pnlStatusBar.add(label3, new GridConstraints(0, 4, 1, 1, GridConstraints.ANCHOR_CENTER, GridConstraints.FILL_NONE, GridConstraints.SIZEPOLICY_FIXED, GridConstraints.SIZEPOLICY_FIXED, null, null, null, 0, false));
        final JLabel label4 = new JLabel();
        Font label4Font = this.$$$getFont$$$("Malgun Gothic", Font.PLAIN, 12, label4.getFont());
        if (label4Font != null) label4.setFont(label4Font);
        label4.setText("Port AGIP ControllerI: ");
        pnlStatusBar.add(label4, new GridConstraints(0, 1, 1, 1, GridConstraints.ANCHOR_WEST, GridConstraints.FILL_NONE, GridConstraints.SIZEPOLICY_FIXED, GridConstraints.SIZEPOLICY_FIXED, null, null, null, 0, false));
        txtApiPort = new JTextField();
        txtApiPort.setEditable(false);
        Font txtApiPortFont = this.$$$getFont$$$("Malgun Gothic", Font.PLAIN, 12, txtApiPort.getFont());
        if (txtApiPortFont != null) txtApiPort.setFont(txtApiPortFont);
        txtApiPort.setHorizontalAlignment(0);
        txtApiPort.setText("-");
        pnlStatusBar.add(txtApiPort, new GridConstraints(0, 2, 1, 1, GridConstraints.ANCHOR_WEST, GridConstraints.FILL_NONE, GridConstraints.SIZEPOLICY_FIXED, GridConstraints.SIZEPOLICY_FIXED, null, new Dimension(60, -1), null, 0, false));
        pnlLog = new JPanel();
        pnlLog.setLayout(new GridLayoutManager(2, 1, new Insets(0, 4, 0, 4), -1, -1));
        rootPanel.add(pnlLog, new GridConstraints(0, 0, 1, 1, GridConstraints.ANCHOR_CENTER, GridConstraints.FILL_BOTH, GridConstraints.SIZEPOLICY_CAN_SHRINK | GridConstraints.SIZEPOLICY_WANT_GROW, GridConstraints.SIZEPOLICY_CAN_SHRINK | GridConstraints.SIZEPOLICY_WANT_GROW, null, null, null, 0, false));
        final JScrollPane scrollPane1 = new JScrollPane();
        Font scrollPane1Font = this.$$$getFont$$$("D2Coding", Font.PLAIN, 12, scrollPane1.getFont());
        if (scrollPane1Font != null) scrollPane1.setFont(scrollPane1Font);
        pnlLog.add(scrollPane1, new GridConstraints(0, 0, 1, 1, GridConstraints.ANCHOR_CENTER, GridConstraints.FILL_BOTH, GridConstraints.SIZEPOLICY_CAN_SHRINK | GridConstraints.SIZEPOLICY_WANT_GROW, GridConstraints.SIZEPOLICY_CAN_SHRINK | GridConstraints.SIZEPOLICY_WANT_GROW, null, null, null, 0, false));
        taLog = new JTextArea();
        taLog.setBackground(new Color(-16777216));
        taLog.setCaretColor(new Color(-1));
        taLog.setEditable(false);
        Font taLogFont = this.$$$getFont$$$("D2Coding", Font.PLAIN, 14, taLog.getFont());
        if (taLogFont != null) taLog.setFont(taLogFont);
        taLog.setForeground(new Color(-1));
        taLog.setMargin(new Insets(4, 4, 4, 4));
        taLog.setText("[10:50:08.561] [ INFO] ************************************************************************************\n[10:50:08.561] [ INFO] **                   Center Communication Server Information                      **\n[10:50:08.561] [ INFO] **     bindAddress: 0.0.0.0\n[10:50:08.561] [ INFO] **      listenPort: 9901\n[10:50:08.561] [ INFO] **         backlog: 1024\n[10:50:08.561] [ INFO] **   acceptThreads: 16\n[10:50:08.561] [ INFO] **   workerThreads: 16\n[10:50:08.561] [ INFO] ************************************************************************************\n");
        scrollPane1.setViewportView(taLog);
        pnlLogTitle = new JPanel();
        pnlLogTitle.setLayout(new GridLayoutManager(1, 7, new Insets(0, 0, 0, 2), 1, 1));
        pnlLog.add(pnlLogTitle, new GridConstraints(1, 0, 1, 1, GridConstraints.ANCHOR_CENTER, GridConstraints.FILL_BOTH, GridConstraints.SIZEPOLICY_CAN_SHRINK | GridConstraints.SIZEPOLICY_CAN_GROW, GridConstraints.SIZEPOLICY_CAN_SHRINK | GridConstraints.SIZEPOLICY_CAN_GROW, null, null, null, 0, false));
        final JLabel label5 = new JLabel();
        Font label5Font = this.$$$getFont$$$("Malgun Gothic", Font.PLAIN, 12, label5.getFont());
        if (label5Font != null) label5.setFont(label5Font);
        label5.setHorizontalAlignment(2);
        label5.setIcon(new ImageIcon(getClass().getResource("/static/image/logging.png")));
        label5.setText("시스템 로그    ");
        pnlLogTitle.add(label5, new GridConstraints(0, 0, 1, 1, GridConstraints.ANCHOR_WEST, GridConstraints.FILL_NONE, GridConstraints.SIZEPOLICY_FIXED, GridConstraints.SIZEPOLICY_FIXED, null, null, null, 0, false));
        final Spacer spacer2 = new Spacer();
        pnlLogTitle.add(spacer2, new GridConstraints(0, 2, 1, 1, GridConstraints.ANCHOR_CENTER, GridConstraints.FILL_HORIZONTAL, GridConstraints.SIZEPOLICY_WANT_GROW, 1, null, null, null, 0, false));
        btnLogDirOpen = new JButton();
        Font btnLogDirOpenFont = this.$$$getFont$$$("Malgun Gothic", Font.PLAIN, 12, btnLogDirOpen.getFont());
        if (btnLogDirOpenFont != null) btnLogDirOpen.setFont(btnLogDirOpenFont);
        btnLogDirOpen.setHorizontalTextPosition(0);
        btnLogDirOpen.setText("로그 폴더");
        pnlLogTitle.add(btnLogDirOpen, new GridConstraints(0, 6, 1, 1, GridConstraints.ANCHOR_CENTER, GridConstraints.FILL_NONE, GridConstraints.SIZEPOLICY_CAN_SHRINK | GridConstraints.SIZEPOLICY_CAN_GROW, GridConstraints.SIZEPOLICY_FIXED, null, null, null, 0, false));
        btnLogPause = new JButton();
        Font btnLogPauseFont = this.$$$getFont$$$("Malgun Gothic", Font.PLAIN, 12, btnLogPause.getFont());
        if (btnLogPauseFont != null) btnLogPause.setFont(btnLogPauseFont);
        btnLogPause.setHorizontalTextPosition(0);
        btnLogPause.setText("지우기");
        pnlLogTitle.add(btnLogPause, new GridConstraints(0, 4, 1, 1, GridConstraints.ANCHOR_CENTER, GridConstraints.FILL_NONE, GridConstraints.SIZEPOLICY_CAN_SHRINK | GridConstraints.SIZEPOLICY_CAN_GROW, GridConstraints.SIZEPOLICY_FIXED, null, null, null, 0, false));
        chkLogPause = new JCheckBox();
        Font chkLogPauseFont = this.$$$getFont$$$("Malgun Gothic", Font.PLAIN, 12, chkLogPause.getFont());
        if (chkLogPauseFont != null) chkLogPause.setFont(chkLogPauseFont);
        chkLogPause.setHorizontalAlignment(0);
        chkLogPause.setHorizontalTextPosition(11);
        chkLogPause.setText("멈춤");
        pnlLogTitle.add(chkLogPause, new GridConstraints(0, 3, 1, 1, GridConstraints.ANCHOR_WEST, GridConstraints.FILL_NONE, GridConstraints.SIZEPOLICY_CAN_SHRINK | GridConstraints.SIZEPOLICY_CAN_GROW, GridConstraints.SIZEPOLICY_FIXED, null, null, null, 0, false));
        btnLogCopy = new JButton();
        Font btnLogCopyFont = this.$$$getFont$$$("Malgun Gothic", Font.PLAIN, 12, btnLogCopy.getFont());
        if (btnLogCopyFont != null) btnLogCopy.setFont(btnLogCopyFont);
        btnLogCopy.setText("복사");
        pnlLogTitle.add(btnLogCopy, new GridConstraints(0, 5, 1, 1, GridConstraints.ANCHOR_CENTER, GridConstraints.FILL_NONE, GridConstraints.SIZEPOLICY_CAN_SHRINK | GridConstraints.SIZEPOLICY_CAN_GROW, GridConstraints.SIZEPOLICY_FIXED, null, null, null, 0, false));
        chkSysDebug = new JCheckBox();
        Font chkSysDebugFont = this.$$$getFont$$$("Malgun Gothic", Font.PLAIN, 12, chkSysDebug.getFont());
        if (chkSysDebugFont != null) chkSysDebug.setFont(chkSysDebugFont);
        chkSysDebug.setText("System Debug Info ");
        pnlLogTitle.add(chkSysDebug, new GridConstraints(0, 1, 1, 1, GridConstraints.ANCHOR_WEST, GridConstraints.FILL_NONE, GridConstraints.SIZEPOLICY_CAN_SHRINK | GridConstraints.SIZEPOLICY_CAN_GROW, GridConstraints.SIZEPOLICY_FIXED, null, null, null, 0, false));
    }

    /**
     * @noinspection ALL
     */
    private Font $$$getFont$$$(String fontName, int style, int size, Font currentFont) {
        if (currentFont == null) return null;
        String resultName;
        if (fontName == null) {
            resultName = currentFont.getName();
        } else {
            Font testFont = new Font(fontName, Font.PLAIN, 10);
            if (testFont.canDisplay('a') && testFont.canDisplay('1')) {
                resultName = fontName;
            } else {
                resultName = currentFont.getName();
            }
        }
        Font font = new Font(resultName, style >= 0 ? style : currentFont.getStyle(), size >= 0 ? size : currentFont.getSize());
        boolean isMac = System.getProperty("os.name", "").toLowerCase(Locale.ENGLISH).startsWith("mac");
        Font fontWithFallback = isMac ? new Font(font.getFamily(), font.getStyle(), font.getSize()) : new StyleContext().getFont(font.getFamily(), font.getStyle(), font.getSize());
        return fontWithFallback instanceof FontUIResource ? fontWithFallback : new FontUIResource(fontWithFallback);
    }

    /**
     * @noinspection ALL
     */
    public JComponent $$$getRootComponent$$$() {
        return rootPanel;
    }

}
